var fs = require('fs');
var path = require('path');
var crypto = require('crypto');

var nonogo = exports;

nonogo.filename = '';

nonogo.cryptoFlag = '';
nonogo.cryptoAlgo = '';
nonogo.cryptoKey = '';

nonogo.data = '';
nonogo.d = {};

nonogo.open = function(filename, cryptoFlag, cryptoAlgo, cryptoKey, callback) {
	nonogo.filename = filename;
	nonogo.cryptoFlag = cryptoFlag;
	nonogo.cryptoAlgo = cryptoAlgo;
	nonogo.cryptoPWD = cryptoKey;
	path.exists(nonogo.filename, function(exists) {
		if (exists)
		{
			console.log('Database exists. Go ahead, keep playing :-)');
			nonogo.get(nonogo.cryptoFlag, nonogo.cryptoAlgo, nonogo.cryptoKey, function(error, collection) {
				try
				{
					if (error) throw error;
                                	process.nextTick(function() {
                                        	callback(error, collection);
                                	});
				}
				catch(err)
				{
                                	process.nextTick(function() {
                                        	callback(err, collection);
                                	});
				}
			});
		}
		else
		{
			console.log('Database does not exist. Creating one now...');
			var writeStream = fs.createWriteStream(nonogo.filename, {flags:'a+', encoding:'utf-8'});
			writeStream.on('open', function() {
				var writeString = '';
				if (nonogo.cryptoFlag == '0')
				{
					writeString = '{}';
				}
				else if(nonogo.cryptoFlag == '1')
				{
					writeString = nonogo.encrypt(nonogo.cryptoAlgo, nonogo.cryptoKey, '{}');
				}
				writeStream.end(writeString, 'utf-8');
			});
			writeStream.on('close', function() {
				nonogo.get(nonogo.cryptoFlag, nonogo.cryptoAlgo, nonogo.cryptoKey, function(error, collection) {
					if (error) throw error;
					process.nextTick(function() {
						var error = false;
						callback(error, collection);
					});
				});
			});
			writeStream.on('error', function(exception) {
				process.nextTick(function() {
					var error = exception;
					var collection = {};
					callback(error, collection);
				});
			});
		}
	});
	return nonogo;
};

nonogo.get = function(cryptoFlag, cryptoAlgo, cryptoKey, callback) {
	nonogo.data = '';
	var readStream = fs.createReadStream(nonogo.filename, {flags:'a+', encoding:'utf-8'});
	readStream.on('error', function(exception) {
		process.nextTick(function() {
			var error = exception;
			callback(error, undefined);
		});
	});
	readStream.on('data', function(data) {
		nonogo.data += data;		
	});
	readStream.on('end', function() {
		try
		{
			var jsonString;
			if (cryptoFlag == '0')
			{
				jsonString = nonogo.data;
			}
			else if (cryptoFlag == '1')
			{
				jsonString = nonogo.decrypt(cryptoAlgo, cryptoKey, nonogo.data);
			}
			nonogo.d = JSON.parse(jsonString);
			process.nextTick(function() {
				var error = false;
				callback(error, nonogo.d);
			});
		}
		catch(err)
		{
			process.nextTick(function() {
                                callback(err, nonogo.d);
                        });
		}
	});
};

nonogo.addRow = function(key, value, callback) {		
	try
	{
		if (!key)
		{
			key = '_' + 0x80000000000 * Math.random() + Date.parse(Date());	
		}
		
		if (nonogo.d[key] == undefined)
		{
			nonogo.d[key] = [];	
		}
		nonogo.d[key].push(value);
		process.nextTick(function() {
			var error = null;
			callback(error, nonogo.d);
		});
	}
	catch(err)
	{
		process.nextTick(function() {
			var error = err;
			callback(error, {});
		});
	}
};

nonogo.addField = function(key, index, field, value, callback) {
	try
	{
		nonogo.d[key][index][field] = value;
		process.nextTick(function() {
			var error = false;
			callback(error, nonogo.d);
		});
	}
	catch(err)
	{
		process.nextTick(function() {
			var error = err;
			callback(error, undefined);
		});
	}
};

nonogo.editRow = function(key, index, value, callback) {
	try
	{
		if (nonogo.d[key][index] != undefined)
		{
			nonogo.d[key][index] = value;
			process.nextTick(function() {
				var error = false;
				callback(error, nonogo.d);
			});
		}
		else
		{
			throw new Error('Field does not exist');
		}
	}
	catch(err)
	{
		process.nextTick(function() {
			var error = err;
			callback(error, undefined);
		});
	}
};

nonogo.editField = function(key, index, field, value, callback) {
	try
	{
		if (nonogo.d[key][index][field] != undefined)
		{
			nonogo.d[key][index][field] = value;
			process.nextTick(function() {
				var error = false;
				callback(error, nonogo.d);
			});
		}
		else
		{
			throw new Error('Field does not exist');
		}
	}
	catch(err)
	{
		process.nextTick(function() {
			var error = err;
			callback(error, undefined);
		});
	}
};

nonogo.deleteKey = function(key, callback) {
	try
	{
		delete nonogo.d[key];
		process.nextTick(function() {
			var error = false;
			callback(error, nonogo.d);
		});
	}
	catch(err)
	{
		process.nextTick(function() {
			var error = err;
			callback(error, undefined);
		});
	}
};

nonogo.deleteRow = function(key, index, callback) {
  try
  {
    nonogo.d[key].splice(index, 1);
    process.nextTick(function() {
      var error = false;
      callback(error, nonogo.d);
    });
  }
  catch(err)
  {
    process.nextTick(function() {
      var error = err;
      callback(error, undefined);
    });
  }
};

nonogo.deleteField = function(key, index, field, callback) {
	try
	{
		delete nonogo.d[key][index][field];
		process.nextTick(function() {
			var error = false;
			callback(error, nonogo.d);
		});
	}
	catch(err)
	{
		process.nextTick(function() {
			var error = err;
			callback(error, undefined);
		});
	}
};

nonogo.deleteAll = function(callback) {
	fs.unlink(nonogo.filename, function(error) {
		process.nextTick(function() {
			var error = false;
			callback(error);
		});
	});
};

nonogo.commit = function(callback) {
	var writeStream = fs.createWriteStream(nonogo.filename, {flags:'w', encoding:'utf-8'});
	var writeString = '';
	if (nonogo.cryptoFlag == '0')
	{
		writeString = JSON.stringify(nonogo.d);
	}
	else if(nonogo.cryptoFlag == '1')
	{
		writeString = nonogo.encrypt(nonogo.cryptoAlgo, nonogo.cryptoKey, JSON.stringify(nonogo.d));
	}
	writeStream.on('open', function() {
		writeStream.end(writeString, 'utf-8');
		process.nextTick(function() {
			var error = false;
			callback(error);
		});
	});
	writeStream.on('error', function(exception) {
		process.nextTick(function() {
			var error = exception;
			callback(error);
		});
	});
};

nonogo.encrypt = function(algorithm, key, plainText) {
	var cipher = crypto.createCipher(algorithm, key);
	var encrypted = cipher.update(plainText, 'utf8', 'hex') + cipher.final('hex');
	
	return encrypted;
};

nonogo.decrypt = function(algorithm, key, cipherText) {
	var decipher = crypto.createDecipher(algorithm, key);
	var decrypted = decipher.update(cipherText, 'hex', 'utf8') + decipher.final('utf8');
	
	return decrypted;
};

nonogo.getRowByField = function(key, field, search, callback) {
	try {
		var results = [];
		for (var i = 0; i < nonogo.d[key].length; i++) {
			if (nonogo.d[key][i][field] == search) {
				results.push(nonogo.d[key][i][field]);
			}
		}
		process.nextTick(function() {
			callback(undefined, results);
		});
	} catch(err) {
		process.nextTick(function() {
			callback(err, []);
		});
	}
};

nonogo.getRowByIndex = function(key, index, callback) {
        try {  
                process.nextTick(function() {
                        callback(undefined, nonogo.d[key][index]);
                });
        } catch(err) {
                process.nextTick(function() {
                        callback(err, undefined);
                });
        }
};
